



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Web开发人员常犯的10个错误</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Web开发人员常犯的10个错误</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 22:06:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>说到开发一个运行在现代网络中的网站：Web开发人员需要选择虚拟主机平台和底层数据存储，准备编写HTML、CSS和JavaScript用的工具，要有设计执行方式，以及一些可用的JavaScript库/框架。在将任务分解为这几步之后，接下来要做的就简单多了，可以去网上找文章，浏览论坛，看看那些能提供更好的Web体验提示的示例。</h4>
<p>然而不管是走哪条路，犯错却是每一个开发人员都不可避免的。虽然有些错误与某一个具体的行为相关，但有些错误却是所有Web开发人员都需要面对的挑战。因此，通过研究，体验和观察，我总结了Web开发人员常犯的10个错误——以及如何避免这些错误。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/321721/201602/321721-20160212092356495-1959147640.png" /></p>
<p>以下要点没有特定的顺序。</p>
<p><strong>1）写一些过时的HTML</strong></p>
<p><strong>错误：</strong>早期的互联网比起我们现在，标记的选择要少得多。然而，旧习难改，现在很多开发人员写的HTML就好像还身处20世纪一样。举例来说，我们使用&lt;table&gt;元素用于布局，当其他特定语义标签更适合的时候使用&lt;span&gt;或&lt;div&gt;元素，在当前HTML标准不受支持的时候使用&lt;center&gt;或&lt;font&gt;标签，在页面上间隔项目，如果有大量&amp;nbsp;字符实体的话。</p>
<p>影响：遵从这种过时的HTML规则可能会导致标记过于复杂，结果是在不同的浏览器中发生不同的行为。而且没有了改进浏览器的动力，因为没有必要更新到最新的浏览器，如Microsoft Edge，哪怕是Internet Explorer版本（11、10、9）也变得没有必要。</p>
<p><strong>如何避免：</strong>停止使用&lt;table&gt;元素用于内容布局，限制使用&lt;table&gt;元素来显示表格数据。例如可以去whatwg.org了解当前可用的标记选项。使用HTML去描述内容是什么，而不是说明内容如何展现。对于如何显示内容，请使用CSS（http://www.w3.org/Style/CSS/）。</p>
<p><strong>2）“明明在我的浏览器中是可行的……”</strong></p>
<p><strong>错误：</strong>开发人员往往会偏爱某一个特定的浏览器，或者特别讨厌某一个，可能主要是因为对测试网页视图有所偏见。也有可能是因为从网上找到的代码示例不能保证会如何呈现在其他浏览器中。此外，一些浏览器对风格有不同的默认值。</p>
<p><strong>影响：</strong>以某一个浏览器为中心写的网站，在其他浏览器中显示时，其质量将会很差。</p>
<p><strong>如何避免：</strong>在开发过程中，在所有浏览器和版本中测试网页是不切实际的。不过，每隔一段时间，在多个浏览器中检查网站的样子不失为一个好方法。现在，不管你偏好的是什么平台，总有免费的工具可用：免费的虚拟机、网站扫描仪。如http://browsershots.org/和https://www.browserstack.com/show网站可以给出页面如何呈现在多个浏览器/版本/平台中的快照。Visual Studio等工具还可以调用多个浏览器，来显示你正在工作的单一页面。当涉及到CSS设计时，可以参考在meyerweb.com中所示的那样“重置”所有的默认值。</p>
<p>如果你的网站正在使用的CSS特性是专为某一浏览器特制的，那么注意它的引擎前缀，如-webkit-，-moz-和-ms-。对于行业在这方面的发展趋势指导，那么可以阅读以下参考：</p>
<ul><li><p><strong>Microsoft Edge开发博客：</strong>A break from the past, part 2: Saying goodbye to ActiveX, VBScript, attachEvent</p></li>
<li><p><strong>QuirksMode.org：</strong>CSS vendor prefixes considered harmful</p></li>
<li><p><strong>Bruce Lawson：</strong> On Internet Explorer supporting -webkit- vendor prefixes</p></li></ul>
<p>上面这些参考资料解说了引擎前缀的革新，以及你还可以点击这里——这个网站提供了一些如何摒弃引擎前缀的实用建议。</p>
<p><strong>3）不好的格式</strong></p>
<p><strong>错误：</strong>提示用户提供信息（特别是在输入文本字段的时候），并假设数据会如预期接收。</p>
<p><strong>影响：</strong>很多事情会（或者很有可能将会）出错，当我们信任用户输入的时候。如果无法提供所需的数据，或接收到的数据不能与下面的数据模式兼容，页面可能会失败。更为严重的是，有的用户可能会故意违背网站的数据库，例如可以通过注入式攻击（见OWASP：Top 10 2013-A1-Injections）。</p>
<p><strong>如何避免：</strong>你首先要做的事是确保用户清楚你需要什么类型的数据。比如说，如果你只说要地址，那用户不知道指的是单位，家庭还是电子邮件的地址！除了要具体，还要充分利用现在的HTML提供的数据验证技术。不管数据在浏览器端是如何验证的，确保它始终也在服务器端验证。不要让一个串接的T-SQL语句使用来自于用户输入的，各个字段的类型没有经过确认的数据。</p>
<p><strong>4）臃肿的响应结果</strong></p>
<p><strong>错误：</strong>页面充满了许多高品质的图形和/或图片，这些图形和/或图片借助img元素的高度和宽度属性按比例缩小。来自于页面链接的文件，如CSS和JavaScript，很大。源HTML标记也可能是不必要的复杂和全面。</p>
<p><strong>影响：</strong>完全渲染页面的时间是如此之久，以致于一些用户放弃了，或者甚至于直接不耐烦地重新请求整个页面。在某些情况下，如果页面处理等待太久，会出现错误。</p>
<p><strong>如何避免：</strong>不要抱有现在互联网接入越来越快的侥幸心态——从而允许臃肿的场景。相反，要将从浏览器到你的网站的来回当为一种成本。图像是网页臃肿的主要罪犯。为了最大限度地减少图像成本，减轻页面加载的压力，可以试试以下三个技巧：</p>
<p>1、问问你自己：“这些图形真的有必要吗？”删除不需要的图片。</p>
<p>2、使用例如Shrink O’Matic或RIOT的工具来减少图像文件大小。</p>
<p>3、预加载图像。这不会提高初始下载的成本，但可以让网站其他页面图像加载速度更快。</p>
<p>另一种减少成本的方式是压缩CSS和JavaScript链接文件。有很多的工具，如Minify CSS和Minify JS都能帮你做到。</p>
<p><strong>5）创建所谓“应该能行”的代码</strong></p>
<p><strong>错误：</strong>无论是JavaScript，还是在服务器上运行的代码，开发人员都需要测试并确认它是否可以正常工作，而不是在部署了之后，就认为它应该就能从一而终地运行。</p>
<p><strong>影响：</strong>不经过适当错误检查的网站就是对最终用户耍流氓。不仅会极大地影响用户体验，而且其错误消息内容的类型可能会给黑客线索来渗透这个站点。</p>
<p><strong>如何避免：</strong>是人都会犯错，这个哲理同样适用于编码。使用JavaScript，一定要实施好的技术来防止并抓住错误。虽然这篇文章描绘了用JavaScript编码Windows应用程序，但是大部分的内容也适用于web开发，许多提示都很不错！另一种能让代码变得可靠又能在未来变化中存活下来的方法是单元测试。</p>
<p>如果我们够仔细，那么就能捕捉到服务器端的代码失败，而不被用户发现。只显示必要的信息，并且一定要确保设置友好的错误页面，如HTTP 404s。</p>
<p><strong>6）写分叉代码</strong></p>
<p><strong>错误：</strong>本着支持所有浏览器和版本的崇高理念，开发人员立志创建可对任意可能情况作出回应的代码。代码中if语句成堆，所有方向都有分叉。</p>
<p><strong>影响：</strong>随着浏览器新版本的更新，代码文件会变得越来越笨拙和难以管理。</p>
<p><strong>如何避免：</strong>实现代码的功能检测和浏览器/版本检测。功能检测技术不仅可以显著减少代码量，还更易于阅读和管理。不妨考虑使用如Modernizr这样的库，不仅有助于功能检测，还能自动帮助提供不能跟上HTML5和CSS3速度的旧版浏览器的反馈支持。</p>
<p><strong>7）非响应式设计</strong></p>
<p><strong>错误：</strong>假设开发/设计人员在相同尺寸的显示器上开发网站。</p>
<p><strong>影响：</strong>当在移动设备或在非常大的屏幕查看网站时，用户体验要么很难看到页面的重要方面，要么甚至要时刻注意着不导航至其他网页。</p>
<p><strong>如何避免：</strong>响应式的思维方式。在网站中使用响应式设计。这里有一些关于这方面的实用教程，包括响应式图片，还有一个非常受欢迎的库，那就是Bootstrap。</p>
<p><strong>8）制作无意义的页面</strong></p>
<p><strong>错误：</strong>制作面向公众内容的网页才是有用的，绝不能不提供关于搜索引擎的任何线索。没有实现可访问性功能。</p>
<p><strong>影响：</strong>如果不能让搜索引擎发现网页，那么，可能会只有少量或根本没有访问。</p>
<p><strong>如何避免：</strong>使用SEO（搜索引擎优化）和HTML的支持可访问性。关于SEO，一定要添加标签以提供有意义的网页关键字和描述。 About Tech就写得很好，可以借鉴。为了能有更好的可访问性功能体验，请对每一个img和area标签提供一个alt=&quot;your image description&quot; 属性。更多建议请见About Tech。你也可以在Cynthia Says测试公共网页，看它是否兼容Section 508。</p>
<p><strong>9）网站过多刷新</strong></p>
<p><strong>错误：</strong>创建的网站需要为每一个互动而全面刷新页面。</p>
<p><strong>影响：</strong>类似于页面臃肿（参见＃4），页面加载时间的性能会受到影响。用户体验缺乏流畅性，并且每次互动都可能导致网页短暂（或长时间）的复位。</p>
<p><strong>如何避免：</strong>快速避免这种情况的一个方法就是，通过测定回发到服务器的内容是否是真正需要的。例如，当不依赖服务器端资源的时候，客户端脚本可用于提供直接结果。你也可以应用AJAX技术或进一步使用单页的应用程序“SPA”方法。流行的JavaScript库/框架，如JQuery、KnockoutJS和AngularJS，能让这些方法的采用变得容易得多。</p>
<p><strong>10）做了太多的无用功</strong></p>
<p><strong>错误：</strong>开发人员花了很长的时间来创建web内容。大量的时间花在了重复的任务上，或者自己敲代码写了很多。</p>
<p><strong>影响：</strong>初始网站的发布和后续的更新时间过于冗长。如果其他开发人员也在在做同样的工作，却用了更少的时间和精力，那么你的开发价值显然就低了。手动劳动很容易出现错误，而排除故障错误需要更多的时间。</p>
<p>如何避免：探索你的选择。在开发的每一个阶段考虑使用新的工具和新的流程技术。例如，你目前使用的代码编辑器相比Sublime Text和Visual Studio，如何？不管你使用的是什么样的代码编辑器，你最近有好好钻研它的功能吗？也许只投入稍稍一点时间去仔细阅读文档，就可以发现做事的新方法，为今后节省一个又一个小时的时间。例如，在这篇文章中，扩展Visual Studio可以为web开发人员提高生产效率。</p>
<p>不要错过网上可用的帮助工具！例如，检查在dev.modern.ie上的工具以简化测试（跨多个平台和设备）以及排除故障。</p>
<p>你也可以通过实现流程自动化以减少时间和错误。这方面的例子是使用Grunt工具，例如它的自动化功能可以减小文件（见第4点）。另一个例子是Bower，可以协助管理库/框架（参见第9点）。</p>
<p>至于web服务器本身？在例如Microsoft Azure Web Apps的帮助下，你可以快速创建一个网站，几乎所有的开发场景都可以很轻轻松松地规模化到你的业务中！</p>
<p><strong>总结</strong></p>
<p>通过识别这些常见的错误，web开发人员可以避免很多让其他人饱受煎熬的挫折。我们不仅需要承认错误，还应该清楚错误的影响，并采取措施避免错误，这样才能有更好的开发表现——并有信心完成任务！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e4llx9.html">Android中Fragment&plus;ViewPager的配合使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8myk368.html">LIS最长上升子序列O&lpar;n&Hat;2&rpar;与O&lpar;nlogn&rpar;的算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlr02xq.html">toString的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4ln5e8.html">nginx对网站限速</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxngvzv8.html">git 教程  git&period;oschina&period;net</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn33408.html">java虚拟机涉及内存溢出</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd603z8.html">Pascal&amp;&num;39&semi;s Triangle&comma;Pascal&amp;&num;39&semi;s Triangle II</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w705lq.html">vs 2005 在IE下断点不起作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojgd4pq.html">让div自适应浏览器窗口居中显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z3y509.html">一款好用的软件easyUI</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoeol1q.html">【转载】WAI-ARIA无障碍网页应用属性完全展示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy17e62q.html">&lbrack;MySQL&rsqb; MVCC 多版本并发控制实现的事务</a>
		</li>
						<li><a href="https://www.batexi.com/a/950op1v8.html">Jdk 接口类RandomAccess了解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9genknz8.html">python 循环 while</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvlzo38.html">Unity琐碎&lpar;3&rpar; UGUI 图文混排解决方案和优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9603v249.html">object detection&lbrack;rfcn&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jd7l3q.html">苹果 ios 微信浏览器界面 ajax 提交带 file 的 form 总是走error方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o13og8.html">Androidstudio&lowbar;LinearLayout</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jvpd5q.html">mariadb中创建外键时的一个奇怪的情况</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m23wgoq.html">mySQL遇到的问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8keze78.html">UIColor 分类 16进制转 RGB</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx33rdq.html">关于collapsed margin（外边距合并）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96re7v9.html">Java EE 参考文档及sample</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r2xx4q.html">mysql Blob存取的一个简单例子</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96reey9.html">【12&lowbar;206】Reverse Linked List</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnxook9.html">【6&lowbar;100】Same Tree</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7561k9.html">Oracle必须死之奇怪的ORA-06502错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m537pq.html">手机端使用rem适配</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kewp38.html">EJDB 1&period;1&period;18 发布，嵌入式JSON数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq17e35q.html">Dynamic CRM 2013学习笔记（三十九）流程2 - 业务流程（Business Process Flows）用法详解</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
